Summary: Advanced Trivial File Transfer Protocol (TFTP) client
Name: atftp
Version: 0.7
Release: 97.vvm%{?dist}
License: GPL
Group: Applications/Internet
URL: ftp://ftp.mamalinux.com/pub/atftp/

Packager: vvm@mammoth.jinr.ru

Source: http://downloads.openwrt.org/sources/atftp-%{version}.tar.gz
Source1: atftpd.sysconfig
Source2: atftpd.init
Source3: atftpd.logrotate
Patch0: atftp-0.7-inlines.patch
Patch1: atftp-0.7-CLK_TCK.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: libtermcap-devel, pcre-devel, ncurses-devel, readline-devel
Requires: binutils, gawk
Provides: tftp

%description
atftp is an advanced client implementation of the TFTP
protocol that implements RFCs 1350, 2090, 2347, 2348, and 2349.
The server is multi-threaded and the client presents a friendly
interface using libreadline. The current server implementation
lacks IPv6 support.

%package server
Summary: Advanced Trivial File Transfer Protocol (TFTP) server
Group: System Environment/Daemons

#Conflicts: tftp-server
Provides: tftp-server

%description server
atftpd is an advanced server implementation of the TFTP
protocol that implements RFCs 1350, 2090, 2347, 2348, and 2349.
The server is multi-threaded and the client presents a friendly
interface using libreadline. The current server implementation
lacks IPv6 support.

%prep
%setup
%patch0 -p1
%patch1

### FIXME: Change location of pcre.h to pcre/pcre.h (Please fix upstream)
if [ -r %{_includedir}/pcre/pcre.h ]; then
    %{__perl} -pi.orig -e 's|\bpcre.h\b|pcre/pcre.h|' configure tftpd_pcre.h
fi

%{__cat} <<EOF >tftp.xinetd
# default: off
# description: The tftp server serves files using the trivial file transfer protocol. The tftp protocol is often used to boot diskless workstations, download configuration files to network-aware printers, and to start the installation process for some operating systems.
service tftp
{
    disable         = yes
    socket_type     = dgram
    protocol        = udp
    wait            = yes
    user            = root
    server          = %{_sbindir}/in.tftpd
    server_args     = /tftpboot
    per_source      = 11
    cps             = 100 2
    flags           = IPv4
}
EOF

%build
%configure \
    --disable-dependency-tracking \
    --enable-libpcre \
    --enable-libreadline \
    --enable-libwrap \
    --enable-mtftp
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%makeinstall

%{__install} -d %{buildroot}/tftpboot/
%{__install} -d %{buildroot}/var/log
%{__install} -Dp -m0644 tftp.xinetd %{buildroot}%{_sysconfdir}/xinetd.d/tftp
%{__install} -Dp -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/tftpd
%{__install} -Dp -m0755 %{SOURCE2} %{buildroot}%{_sysconfdir}/rc.d/init.d/tftpd
%{__install} -Dp -m0755 %{SOURCE3} %{buildroot}%{_sysconfdir}/logrotate.d/atftpd
touch %{buildroot}/var/log/atftpd.log

%clean
%{__rm} -rf %{buildroot}

%post server
if [ "$1" = "1" ] ; then
   /sbin/chkconfig --add tftpd
fi

%preun server
if [ "$1" = "0" ] ; then
   /etc/init.d/tftpd stop &>/dev/null || :
   /sbin/chkconfig --del tftpd
fi

%postun server
if [ $1 -ge 1 ] ; then
   /sbin/service tftpd condrestart > /dev/null 2>&1 || :
fi

%files
%defattr(-, root, root, 0755)
%doc BUGS Changelog FAQ INSTALL LICENSE README* TODO
%doc %{_mandir}/man1/atftp.1*
%{_bindir}/atftp

%files server
%defattr(-, root, root, 0755)
%doc docs/*
%doc %{_mandir}/man8/atftpd.8*
%doc %{_mandir}/man8/in.tftpd.8*
%dir /tftpboot/
%config(noreplace) %{_sysconfdir}/xinetd.d/tftp
%config(noreplace) %{_sysconfdir}/sysconfig/tftpd
%{_sysconfdir}/logrotate.d/atftpd
%{_sysconfdir}/rc.d/init.d/tftpd
%{_sbindir}/atftpd
%{_sbindir}/in.tftpd
%attr(0644,nobody,nobody) /var/log/atftpd.log

%changelog
* Mon May 28 2011 vvm@mammoth.jinr.ru
- start standalone

* Thu Dec 27 2007 Jameson <imntreal@gmail.com> - 0.7.0-6 - 7981/dag
- Patched CLK_TCK error

* Mon Mar 13 2006 Dag Wieers <dag@wieers.com> - 0.7.0-5
- Removed readline and readline-devel as a dependency.

* Sat Mar 11 2006 Dag Wieers <dag@wieers.com> - 0.7.0-4
- Moved tftp xinetd config to atftp-server. (Diego Torres Milano)
- Fixed FC4 build.

* Sun Mar 28 2004 Dag Wieers <dag@wieers.com> - 0.7.0-3
- Removed Conflicts-tag.

* Thu Mar 25 2004 Dag Wieers <dag@wieers.com> - 0.7.0-2
- Provide tftp and tftp-server.

* Sat Mar 20 2004 Dag Wieers <dag@wieers.com> - 0.7.0-1
- Updated to new release 0.7.0.

* Sat Aug 23 2003 Dag Wieers <dag@wieers.com> - 0.6.2-1
- Conflicts with tftp-server package.
- Added xinetd script.

* Sat Aug 23 2003 Dag Wieers <dag@wieers.com> - 0.6.2-0
- Initial package. (using DAR)
